<template>
  <portal-page class="q-pa-lg">
    <div class="row">
      <div class="col-1 q-mt-sm q-mr-sm">
        <p class="title-msg title-medium text-green-10">My Jobs</p>
      </div>

      <div class="col flex flex-start">
        <q-tabs v-model="tab" class="text-grey-7" inline-label align="justify">
          <q-tab name="active" label="Active" class="q-mx-lg">
            <q-badge
              v-show="notificationCount('Active')"
              color="green-10"
              rounded
              class="q-mb-md"
            >
              <span class="notification q-mx-auto">
                {{ notificationCount("Active") }}
              </span>
            </q-badge>
          </q-tab>
          <q-tab name="pending" label="Pending" class="q-mx-lg">
            <q-badge
              v-show="notificationCount('Pending')"
              color="green-10"
              rounded
              class="q-mb-md"
            >
              <span class="notification q-mx-auto">
                {{ notificationCount("Pending") }}</span
              >
            </q-badge>
          </q-tab>
          <q-tab name="archived" label="Archived" class="q-mx-lg">
            <q-badge
              v-show="notificationCount('Archived')"
              color="green-10"
              rounded
              class="q-mb-md"
            >
              <span class="notification q-mx-auto">
                {{ notificationCount("Archived") }}</span
              >
            </q-badge>
          </q-tab>
        </q-tabs>
      </div>

      <div class="col" align="right">
        <q-btn
          unelevated
          class="btn-lg"
          label="POST JOB"
          color="green-10"
          @click="showPostJobDialog = true"
        />
      </div>
    </div>

    <div class="row q-py-lg">
      <div class="col">
        <q-tab-panels v-model="tab">
          <q-tab-panel name="active">
            <div>
              <active-jobs-table
                :rows="jobStore.activeJobs"
                :loading="jobStore.activeLoading"
                @view-job="viewJob"
              >
                <template #top> </template>
              </active-jobs-table>
            </div>
          </q-tab-panel>

          <q-tab-panel name="pending">
            <div>
              <pending-jobs-table
                :rows="jobStore.pendingJobs"
                :loading="jobStore.pendingLoading"
                @view-job="viewJob"
              >
                <template #top> </template>
              </pending-jobs-table>
            </div>
          </q-tab-panel>

          <q-tab-panel name="archived">
            <div>
              <archived-jobs-table
                :rows="jobStore.archivedJobs"
                :loading="jobStore.archivedLoading"
                @view-job="viewJob"
              >
                <template #top> </template>
              </archived-jobs-table>
            </div>
          </q-tab-panel>
        </q-tab-panels>
      </div>
    </div>
  </portal-page>

  <!-- DIALOG: POST JOB -->
  <q-dialog
    v-model="showPostJobDialog"
    persistent
    @hide="showPostJobDialog === false"
  >
    <q-card
      flat
      class="q-pa-sm q-mt-lg rounded-borders-10"
      style="width: 1300px; max-width: 90vw"
    >
      <q-card-section class="row items-center q-pb-none">
        <span class="title-headline text-green-10">Create a new job post</span>
        <q-space />
        <q-btn size="md" icon="eva-close" flat round dense v-close-popup />
      </q-card-section>

      <q-card-section>
        <q-form @submit="addJobPost(form)">
          <div class="row q-pa-sm">
            <div class="col">
              <label class="text-caption text-weight-bold text-grey-7-7"
                >JOB TITLE <span class="text-negative">*</span></label
              >
              <q-input
                v-model="form.job_title"
                dense
                outlined
                class="q-mt-sm"
                :rules="[validations.requiredField]"
              />
            </div>
          </div>

          <div class="row q-pa-sm">
            <div class="col">
              <label class="text-caption text-weight-bold text-grey-7-7"
                >JOB DETAILS/DESCRIPTION
                <span class="text-negative">*</span></label
              >
              <q-editor
                v-model="form.job_description"
                min-height="10rem"
                min-width="100%"
                class="q-mt-sm"
                :rules="[validations.requiredField]"
                :dense="$q.screen.lt.md"
                :toolbar="[]"
              />

              <!-- :toolbar="[
                  ['bold', 'italic', 'strike', 'underline'],
                  ['link'],
                  [
                    {
                      label: $q.lang.editor.align,
                      icon: $q.iconSet.editor.align,
                      fixedLabel: true,
                      list: 'only-icons',
                      options: ['left', 'center', 'right', 'justify'],
                    },
                  ],
                  ['unordered', 'ordered', 'outdent', 'indent'],
                ]" -->
            </div>
          </div>

          <div class="row q-gutter-lg q-pa-sm">
            <div class="col">
              <label class="text-caption text-weight-bold text-grey-7-7"
                >ADDRESS (CITY) <span class="text-negative">*</span></label
              >
              <q-select
                v-model="form.city_id"
                :options="cityOptions"
                use-input
                hide-selected
                fill-input
                input-debounce="0"
                option-label="name"
                option-value="id"
                map-options
                emit-value
                dense
                outlined
                class="q-mt-sm"
                @filter="filterCityOptions"
                :rules="[validations.requiredField]"
              >
                <template v-slot:no-option>
                  <q-item>
                    <q-item-section class="text-grey-7">
                      No results
                    </q-item-section>
                  </q-item>
                </template>
              </q-select>
            </div>

            <div class="col">
              <label class="text-caption text-weight-bold text-grey-7-7"
                >ADDRESS (BARANGAY) <span class="text-negative">*</span></label
              >
              <q-select
                v-model="form.barangay_id"
                :options="barangayOptions"
                use-input
                hide-selected
                fill-input
                input-debounce="0"
                option-label="name"
                option-value="id"
                map-options
                emit-value
                dense
                outlined
                class="q-mt-sm"
                @filter="filterBarangayOptions"
                :rules="[validations.requiredField]"
              >
                <template v-slot:no-option>
                  <q-item>
                    <q-item-section class="text-grey-7">
                      No results
                    </q-item-section>
                  </q-item>
                </template>
              </q-select>
            </div>

            <div class="col">
              <label class="text-caption text-weight-bold text-grey-7-7"
                >ADDRESS (STREET) <span class="text-negative">*</span></label
              >
              <q-input
                v-model="form.street"
                dense
                outlined
                class="q-mt-sm"
                :rules="[validations.requiredField]"
              />
            </div>
          </div>

          <div class="row q-gutter-lg q-pa-sm">
            <div class="col">
              <label class="text-caption text-weight-bold text-grey-7-7"
                >INDUSTRY <span class="text-negative">*</span></label
              >
              <q-select
                v-model="form.industry_id"
                :options="industryOptions"
                use-input
                hide-selected
                fill-input
                input-debounce="0"
                option-label="name"
                option-value="id"
                map-options
                emit-value
                dense
                outlined
                class="q-mt-sm"
                @filter="filterIndustryOptions"
                :rules="[validations.requiredField]"
              >
                <template v-slot:no-option>
                  <q-item>
                    <q-item-section class="text-grey-7">
                      No results
                    </q-item-section>
                  </q-item>
                </template>
              </q-select>
            </div>

            <div class="col">
              <div class="row">
                <div class="col">
                  <label class="text-caption text-weight-bold text-grey-7-7"
                    >SALARY RANGE (START)</label
                  >
                  <q-input
                    v-model="form.salary_from"
                    dense
                    outlined
                    class="q-mt-sm q-mr-md"
                  />
                </div>

                <div class="col">
                  <label class="text-caption text-weight-bold text-grey-7-7"
                    >SALARY RANGE (END)</label
                  >
                  <q-input
                    v-model="form.salary_to"
                    dense
                    outlined
                    class="q-mt-sm"
                  />
                </div>
              </div>
            </div>

            <div class="col">
              <label class="text-caption text-weight-bold text-grey-7-7"
                >NO. OF VACANCIES</label
              >
              <q-input
                v-model="form.vacancy_number"
                dense
                outlined
                class="q-mt-sm"
              />
            </div>
          </div>

          <div class="row q-gutter-lg q-pa-sm">
            <div class="col">
              <label class="text-caption text-weight-bold text-grey-7-7"
                >YEARS OF EXPERIENCE</label
              >
              <q-input
                v-model="form.years_of_experience"
                dense
                outlined
                class="q-mt-sm"
              />
            </div>

            <div class="col">
              <label class="text-caption text-weight-bold text-grey-7-7"
                >NO. OF TRAINING HOURS</label
              >
              <q-input
                v-model="form.training_hours"
                dense
                outlined
                class="q-mt-sm"
              />
            </div>

            <div class="col">
              <div class="row">
                <div class="col">
                  <label class="text-caption text-weight-bold text-grey-7-7"
                    >JOB POST VALIDITY (START)
                    <span class="text-negative">*</span></label
                  >

                  <q-input
                    dense
                    outlined
                    v-model="form.validity_date_from"
                    class="q-mt-sm q-mr-md"
                    mask="date"
                    :rules="[validations.requiredField]"
                  >
                    <template v-slot:append>
                      <q-icon
                        name="eva-calendar-outline"
                        class="cursor-pointer"
                      >
                        <q-popup-proxy
                          cover
                          transition-show="scale"
                          transition-hide="scale"
                        >
                          <q-date v-model="form.validity_date_from">
                            <div class="row items-center justify-end">
                              <q-btn
                                v-close-popup
                                label="Close"
                                color="primary"
                                flat
                              />
                            </div>
                          </q-date>
                        </q-popup-proxy>
                      </q-icon>
                    </template>
                  </q-input>
                </div>

                <div class="col">
                  <label class="text-caption text-weight-bold text-grey-7-7"
                    >JOB POST VALIDITY (END)
                    <span class="text-negative">*</span></label
                  >
                  <q-input
                    dense
                    outlined
                    v-model="form.validity_date_to"
                    class="q-mt-sm"
                    mask="date"
                    :rules="[validations.requiredField]"
                  >
                    <template v-slot:append>
                      <q-icon
                        name="eva-calendar-outline"
                        class="cursor-pointer"
                      >
                        <q-popup-proxy
                          cover
                          transition-show="scale"
                          transition-hide="scale"
                        >
                          <q-date v-model="form.validity_date_to">
                            <div class="row items-center justify-end">
                              <q-btn
                                v-close-popup
                                label="Close"
                                color="primary"
                                flat
                              />
                            </div>
                          </q-date>
                        </q-popup-proxy>
                      </q-icon>
                    </template>
                  </q-input>
                </div>
              </div>
            </div>
          </div>

          <div class="row q-gutter-lg q-pa-sm">
            <div class="col">
              <label class="text-caption text-weight-bold text-grey-7-7"
                >EXPERIENCE LEVEL</label
              >
              <div>
                <q-checkbox
                  class="text__regular"
                  color="green-4"
                  v-model="form.entry_level"
                  label="Entry-Level"
                />
              </div>

              <div>
                <q-checkbox
                  class="text__regular"
                  color="green-4"
                  v-model="form.intermediate"
                  label="Intermediate"
                />
              </div>

              <div>
                <q-checkbox
                  class="text__regular"
                  color="green-4"
                  v-model="form.expert"
                  label="Expert"
                />
              </div>
            </div>

            <div class="col">
              <label class="text-caption text-weight-bold text-grey-7-7"
                >JOB TYPE</label
              >
              <div>
                <q-checkbox
                  class="text__regular"
                  color="green-4"
                  v-model="form.full_time"
                  label="Full-Time"
                />
              </div>

              <div>
                <q-checkbox
                  class="text__regular"
                  color="green-4"
                  v-model="form.part_time"
                  label="Part-Time"
                />
              </div>

              <div>
                <q-checkbox
                  class="text__regular"
                  color="green-4"
                  v-model="form.freelance_or_contract"
                  label="Freelance/Contract"
                />
              </div>
            </div>

            <div class="col">
              <label class="text-caption text-weight-bold text-grey-7-7"
                >OTHER</label
              >
              <div>
                <q-checkbox
                  class="text__regular"
                  color="green-4"
                  v-model="form.on_site"
                  label="On-Site"
                />
              </div>

              <div>
                <q-checkbox
                  class="text__regular"
                  color="green-4"
                  v-model="form.remote"
                  label="Remote"
                />
              </div>

              <div>
                <q-checkbox
                  class="text__regular"
                  color="green-4"
                  v-model="form.hybrid"
                  label="Hybrid"
                />
              </div>
            </div>
          </div>

          <div class="q-py-lg" align="center">
            <p class="text-negative text-center">
              {{ errorMessage }}
            </p>
            <q-btn
              class="btn-lg text-white"
              color="green-10"
              type="submit"
              label="SUBMIT"
              :loading="loading"
            />
          </div>
        </q-form>
      </q-card-section>
    </q-card>
  </q-dialog>
</template>

<script>
import PortalPage from "src/layouts/portals/PortalPage.vue";
import ActiveJobsTable from "../components/tables/ActiveJobsTable.vue";
import PendingJobsTable from "../components/tables/PendingJobsTable.vue";
import ArchivedJobsTable from "../components/tables/ArchivedJobsTable.vue";
import useJobHook from "../hooks/jobHook";
import useNotification from "src/hooks/notification";
import { useJob } from "../store/job";
import { EmployerJobPostApi } from "src/hooks/api";
// import { useReference } from "../store/reference";
import { useReference } from "src/modules/auth/store/reference";
import { defineComponent, ref, reactive } from "vue";
import { requiredField } from "src/hooks/validations";
import { useEmployer } from "src/layouts/portals/store/employer";
import { pusher } from "boot/pusher";
import { onMounted } from "vue";

export default defineComponent({
  name: "MyJobsEmployerPage",
  components: {
    PortalPage,
    ActiveJobsTable,
    PendingJobsTable,
    ArchivedJobsTable,
  },

  setup() {
    const jobStore = useJob();
    const { getActiveJobs, getPendingJobs, getArchivedJobs } = jobStore;

    const referenceStore = useReference();
    const { getCities, getBarangays, getIndustries } = referenceStore;

    const employerStore = useEmployer();
    const { getNotificationCount, setRefresh } = employerStore;

    onMounted(() => {
      getCities();
      getBarangays();
      getIndustries();
      getActiveJobs({ status: "approved" });
      getPendingJobs({ status: "pending" });
      getArchivedJobs({ is_archived: 1 });
      pusherBind();
    });

    const { loading, doCreateJobPost } = useJobHook();
    const { showNotif } = useNotification();
    const isError = ref(false);
    const errorMessage = ref("");
    const showPostJobDialog = ref(false);
    const industryOptions = ref(referenceStore.industries);
    const cityOptions = ref(referenceStore.cities);
    const barangayOptions = ref(referenceStore.barangays);

    const form = reactive({
      job_title: null,
      job_description: null,
      street: null,
      city_id: null,
      barangay_id: null,
      industry_id: null,
      salary_from: null,
      salary_to: null,
      validity_date_from: null,
      validity_date_to: null,
      vacancy_number: null,
      years_of_experience: null,
      training_hours: null,
      entry_level: false,
      intermediate: false,
      expert: false,
      full_time: false,
      part_time: false,
      freelance_or_contract: false,
      on_site: false,
      remote: false,
      hybrid: false,
    });

    const resetForm = () => {
      form.job_title = null;
      form.job_description = null;
      form.street = null;
      form.city_id = null;
      form.barangay_id = null;
      form.industry_id = null;
      form.salary_from = null;
      form.salary_to = null;
      form.validity_date_from = null;
      form.validity_date_to = null;
      form.vacancy_number = null;
      form.years_of_experience = null;
      form.training_hours = null;
      form.entry_level = false;
      form.intermediate = false;
      form.expert = false;
      form.full_time = false;
      form.part_time = false;
      form.freelance_or_contract = false;
      form.on_site = false;
      form.remote = false;
      form.hybrid = false;
    };

    const pusherBind = () => {
      pusher.connection.bind("message", (msg) => {
        if (msg.event == "pending-job-post") {
          console.log("event: pending-job-post");
          console.log("msg: ", msg);
          getPendingJobs({ status: "pending" });
        } else if (msg.event == "active-job-post") {
          console.log("event: active-job-post");
          console.log("msg: ", msg);
          getActiveJobs({ status: "approved" });
        }
      });
    };

    const addJobPost = async (payload) => {
      loading.value = true;

      await EmployerJobPostApi.create(payload)
        .then(() => {
          showNotif({
            message:
              "You job post has been submitted for review by the PESO admin. Once the job post is approved you will be notified.",
            color: "positive",
            position: "bottom-right",
          });
        })
        .catch((error) => {
          isError.value = true;
          errorMessage.value = error?.response?.data?.message.toUpperCase();
        })
        .finally(() => {
          resetForm();
          loading.value = false;
          showPostJobDialog.value = false;
        });
    };

    const notificationCount = (title) => {
      if (employerStore.notificationCount) {
        if (title == "Active") {
          return employerStore.notificationCount.active;
        } else if (title == "Pending") {
          return employerStore.notificationCount.pending;
        } else if (title == "Archived") {
          return employerStore.notificationCount.archived;
        }
      }
      return 0;
    };

    const viewJob = (job) => {
      console.log("viewJob: ", job);
      setRefresh(job.employer_read_at == null);
    };

    return {
      jobStore,
      referenceStore,
      form,
      showPostJobDialog,
      loading,
      isError,
      errorMessage,
      industryOptions,
      cityOptions,
      barangayOptions,
      notificationCount,
      tab: ref("active"),
      viewJob,
      validations: {
        requiredField,
      },
      addJobPost,
      doCreateJobPost,
      filterIndustryOptions(val, update, abort) {
        update(() => {
          const needle = val.toLowerCase();
          industryOptions.value = referenceStore.industries.filter(
            (v) => v.name.toLowerCase().indexOf(needle) > -1
          );
        });
      },
      filterCityOptions(val, update, abort) {
        update(() => {
          const needle = val.toLowerCase();
          cityOptions.value = referenceStore.cities.filter(
            (v) => v.name.toLowerCase().indexOf(needle) > -1
          );
        });
      },
      filterBarangayOptions(val, update, abort) {
        update(() => {
          const needle = val.toLowerCase();
          barangayOptions.value = referenceStore.barangays.filter(
            (v) => v.name.toLowerCase().indexOf(needle) > -1
          );
        });
      },
    };
  },
});
</script>

<style lang="scss" scoped>
.title-msg {
  color: $brand-3 !important;
  margin: 0 !important;
}

div.q-tab {
  width: 100% !important;
  background-color: #f1f1f1 !important;
  color: grey !important;
  padding: 0 7px 2px 7px !important;
  border-radius: 0 !important;

  &__content {
    padding: 0 !important;
  }
  &--active {
    color: #86bb05 !important;
    border-bottom: 2px solid #86bb05 !important;
    background: #f1f1f1 !important;
  }
}

.q-tab--active .q-tab__indicator {
  opacity: 1 !important;
}

.q-editor {
  border-radius: 10px;
  // background: #f5f5f5;
  width: 100%;
}

div.q-tab-panel {
  padding: 0 !important;
}

div.q-badge {
  width: 22px;
  height: 22px;
  padding: 4px 7px;
  background: #016925;
  border-radius: 50px;
  margin-left: 10px !important;
  display: flex;
  justify-content: center;
  align-items: center;
}
</style>
